=== debian/control ===
Source: klatexformula
Section: tex
Priority: extra
Maintainer: Tobias Winchen <winchen@physik.rwth-aachen.de> 
Build-Depends: debhelper (>= 9), docbook-to-man, cmake, libqt4-dev, pkg-kde-tools, kdelibs5-dev, libx11-dev, chrpath
Standards-Version: 3.9.6
Vcs-git: git://github.com/winchen/klatexformula_debian.git
Vcs-Browser: https://github.com/winchen/klatexformula_debian
Homepage: http://klatexformula.sourceforge.net/

Package: klatexformula
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI to easily get an image from a LaTeX formula or equation
 With klatexformula, just enter a formula and click "Evaluate" to get an image
 of a LaTeX formula. You can drag&drop, copy or save the resulting image
 directly from the GUI, which makes klatexformula a very convenient tool for
 presentations. Klatexformula also provides also tools for equation prototyping
 in LaTeX and a user-library of used equations.

Package: libklatexformula3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Runtime libraries for klatexformula 
 With Klatexformula, just enter a formula and click "Evaluate" to get an image
 of a LaTeX formula. You can drag&drop, copy or save the resulting image
 directly from the GUI, which makes klatexformula a very convenient tool for
 presentations. Klatexformula also provides also tools for equation prototyping
 in LaTeX and a user-library of used equations.
 This package provides the libraries klatexformula is based on.

Package: libklatexformula3-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libklatexformula3 (= ${binary:Version}) 
Description: Runtime libraries for klatexformula, development files 
 With Klatexformula, just enter a formula and click "Evaluate" to get an image
 of a LaTeX formula. You can drag&drop, copy or save the resulting image
 directly from the GUI, which makes klatexformula a very convenient tool for
 presentations. Klatexformula also provides also tools for equation prototyping
 in LaTeX and a user-library of used equations.
 This package contains the header files and static libraries to build the
 klatexformula libraries.
