=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)(beta\d*)$/$1~$2/ \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=sf/klatexformula \
.*=klatexformula(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
